# std::shared_timed_mutex::lock

From cppreference.com
< cpp‎ | thread‎ | shared timed mutex

void lock(); |  | (since C++14)

Locks the mutex. If another thread has already locked the mutex, a call to `lock` will block execution until the lock is acquired.

If `lock` is called by a thread that already owns the `mutex` in any mode (shared or exclusive), the behavior is undefined.

Prior unlock() operations on the same mutex synchronize-with (as defined in std::memory_order) this operation.

### Parameters

(none)

### Return value

(none)

### Exceptions

Throws std::system_error when errors occur, including errors from the underlying operating system that would prevent `lock` from meeting its specifications. The mutex is not locked in the case of any exception being thrown.

### Notes

`lock()` is usually not called directly: std::unique_lock and std::lock_guard are used to manage exclusive locking.

Shared mutexes do not support direct transition from shared to unique ownership mode: the shared lock has to be relinquished with unlock_shared() before exclusive ownership may be obtained with `lock()`. boost::upgrade_mutex may be used for this purpose.

### Example

This example shows how `lock` and `unlock` can be used to protect shared data.

Run this code

    #include <iostream>
    #include <chrono>
    #include <thread>
    #include <mutex>

    int g_num = 0;  // protected by g_num_mutex
    std::mutex g_num_mutex;

    void slow_increment(int id)
    {
        for (int i = 0; i < 3; ++i) {
            g_num_mutex.lock();
            ++g_num;
            std::cout << id << " => " << g_num << '\n';
            g_num_mutex.unlock();

            std::this_thread::sleep_for(std::chrono::seconds(1));
        }
    }

    int main()
    {
        std::thread t1(slow_increment, 0);
        std::thread t2(slow_increment, 1);
        t1.join();
        t2.join();
    }

Possible output:

    0 => 1
    1 => 2
    0 => 3
    1 => 4
    0 => 5
    1 => 6

### See also

try_lock | tries to lock the mutex, returns if the mutex is not available (public member function)
unlock | unlocks the mutex (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/thread/shared_timed_mutex/lock&oldid=68934"